POJ3680:Intervals(离散化+最大流最小费用)

Intervals

Time Limit: 5000MS   Memory Limit: 65536K
Total Submissions: 9320   Accepted: 4014

题目链接:http://poj.org/problem?id=3680

Description:

You are given N weighted open intervals. The ith interval covers (aibi) and weighs wi. Your task is to pick some of the intervals to maximize the total weights under the limit that no point in the real axis is covered more than k times.

Input:

The first line of input is the number of test case.
The first line of each test case contains two integers, N and K (1 ≤ K ≤ N ≤ 200).
The next N line each contain three integers aibiwi(1 ≤ ai < bi ≤ 100,000, 1 ≤ wi ≤ 100,000) describing the intervals. 
There is a blank line before each test case.

Output:

For each test case output the maximum total weights in a separate line.

Sample Input:

4

3 1
1 2 2
2 3 4
3 4 8

3 1
1 3 2
2 3 4
3 4 8

3 1
1 100000 100000
1 2 3
100 200 300

3 2
1 100000 100000
1 150 301
100 200 300

Sample Output:

14
12
100000
100301

题意:

给出n个开区间,每个区间都有其权值,现在要求选择权值和最大的几个区间,并且每个点被区间覆盖的次数不超过k。注意这里的点不是整数点,是数轴上面所有的点。

题解:

区间覆盖的权值问题也可以用网络流...orz

我们并不关系区间边界的具体大小,只需要知道其相对大小就行了,所以我们可以考虑进行离散化,以免空间太大数组不能存储。

这里我们首先将点排序、去重、离散化后,0->1,1->2....p->p+1连一条容量为k的边,表示经过这些边的流量不能超过k。

然后根据我们输入的区间,比如离散化后的点为p,q,那么连一条p->q容量为1费用为相应负权值的边。

最后跑个最大流量最小费用就行啦~

这样建图为什么是正确的呢?我想的是总流量不超过k则限制了每个点的覆盖次数,对于两个不相交的区间,那么一个流则可以跑完。对于相交的区间,则需要多的流才能够跑完。

这种建图方式虽然不是很直观,但是yy一下就好了。

代码如下:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#define mp make_pair
#define fir first
#define sec second
#define INF 1e9
using namespace std;
typedef long long ll;
typedef pair<int,int> pii;
const int N = 505;
int n,k,T;
int head[N],vis[N],d[N],a[N],pa[N],pre[N];
struct Edge{
    int v,next,c,w;
}e[N*N<<3];
int tot ;
void adde(int u,int v,int c,int w){
    e[tot].v=v;e[tot].next=head[u];e[tot].w=w;e[tot].c=c;head[u]=tot++;
    e[tot].v=u;e[tot].next=head[v];e[tot].w=-w;e[tot].c=0;head[v]=tot++;
}
int spfa(int s,int t,int &flow,int &cost){
    for(int i=0;i<=t;i++) d[i]=a[i]=INF;d[s]=0;
    memset(vis,0,sizeof(vis));vis[s]=1;
    memset(pre,-1,sizeof(pre));memset(pa,-1,sizeof(pa));
    queue <int> q;q.push(s);
    while(!q.empty()){
        int u=q.front();q.pop();vis[u]=0;
        for(int i=head[u];i!=-1;i=e[i].next){
            int v=e[i].v;
            if(e[i].c>0 && d[v]>d[u]+e[i].w){
                d[v]=d[u]+e[i].w;
                pa[v]=u;pre[v]=i;
                a[v]=min(a[u],e[i].c);
                if(!vis[v]){
                    vis[v]=1;
                    q.push(v);
                }
            }
        }
    }
    if(d[t]==INF) return 0;
    flow+=a[t];
    cost+=a[t]*d[t];
    for(int i=t;i!=-1;i=pa[i]){
        int edge = pre[i];
        e[edge].c-=a[t];
        e[edge^1].c+=a[t];
    }
    return 1;
}
int Min_cost(int s,int t){
    int flow=0,cost=0;
    while(spfa(s,t,flow,cost));
    return cost;
}
int main(){
    cin>>T;
    while(T--){
        tot=0;memset(head,-1,sizeof(head));
        scanf("%d%d",&n,&k);
        vector <int> x;
        vector <pair<pii,int> > g;
        for(int i=1;i<=n;i++){
            int u,v,w;
            scanf("%d%d%d",&u,&v,&w);
            x.push_back(u);x.push_back(v);
            g.push_back(mp(mp(u,v),w));
        }
        sort(x.begin(),x.end());
        x.erase(unique(x.begin(),x.end()),x.end());
        int len = x.size();
        for(int i=0;i<=len;i++) adde(i,i+1,k,0);
        for(int i=0;i<n;i++){
            int u=g[i].fir.fir,v=g[i].fir.sec,w=g[i].sec;
            int p1 = lower_bound(x.begin(),x.end(),u)-x.begin()+1;
            int p2 = lower_bound(x.begin(),x.end(),v)-x.begin()+1;
            adde(p1,p2,1,-w);
        }
        printf("%d\n",-Min_cost(0,len+1));
    }
    return 0;
}
/*
2
4 2
6 10 4
1 8 10
10 19 3
8 14 1

4 2
2 4 4
1 3 3
4 6 2
3 5 1
*/

原文地址:https://www.cnblogs.com/heyuhhh/p/10162396.html

时间: 2024-10-16 17:21:56

POJ3680:Intervals(离散化+最大流最小费用)的相关文章

POJ3680 Intervals(最小费用最大流)

选择若干条线段使权值最大,并且点覆盖次数不超过k. 建图如下:vs到0建立容量为k费用为0的边:坐标终点到vt连接一条容量为k费用为0的边:对于每两个相邻坐标连接一条容量为INF费用为0的边:对于线段每两个端点连接一条容量1费用为-cost的边. 这样跑最小费用最大流.相当于找出k个线段集合,每个集合的线段都不重合.原问题就这样求解. 1 #include<cstdio> 2 #include<cstring> 3 #include<queue> 4 #include&

poj3680 Intervals 区间k覆盖问题 最小费用最大流 建图巧妙

/** 题目:poj3680 Intervals 区间k覆盖问题 最小费用最大流 建图巧妙 链接:http://poj.org/problem?id=3680 题意:给定n个区间,每个区间(ai,bi),以及权值wi.选出一些区间,满足权值和最大且任何一个点不会被超过k个区间覆盖. 思路: 建图:对于每个区间(ai,bi). ai->bi,cap = 1,cost = -wi; (离散化后的ai,bi) 所有区间的端点放到数组,进行从小到大排序,去重,离散化,在数组内相邻的u端点,v端点.u->

Poj3680 Intervals

这题比较经典,题意大致上就是给你n个点和m个区间,每个区间有一个正权值,让你选出一些区间,使得每个点都不会被覆盖超过k次,且选出的区间权值和最大. ------------------------------------------------------------------------------------------------------------------------------------------------------------------------- lyd: 首

解题报告 之 POJ3680 Intervals

解题报告 之 POJ3680 Intervals Description You are given N weighted open intervals. The ith interval covers (ai, bi) and weighs wi. Your task is to pick some of the intervals to maximize the total weights under the limit that no point in the real axis is c

poj3680 Intervals (费用流)

建图((x,y,c,l)表示x到y,费用c,流量l) (S,1,0,K) (i,i+1,0,K) 这个边上的流量,表示i还可以被覆盖的次数 (N,T,0,K) (i,j,w,1)对于权值为w的区间[i,j] 然后跑最大费用最大流 因为没有负权值,所以肯定尽量跑满 1 #include<cstring> 2 #include<cstdio> 3 #include<algorithm> 4 #include<queue> 5 #define CLR(a,x) m

POJ 3680: Intervals【最小费用最大流】

题目大意:你有N个开区间,每个区间有个重量wi,你要选择一些区间,使得满足:每个点被不超过K个区间覆盖的前提下,重量最大 思路:感觉是很好想的费用流,把每个区间首尾相连,费用为该区间的重量的相反数(由于要最大,所以是求最大费用最大流),容量为1,至于不超过K的限制,只要从源点到第一个点的流量为K就行,剩下每个相邻的点相连,费用为0,流量只要大于的等于K就可以(我取的正无穷) //poj3680 #include <stdio.h> #include <iostream> #incl

题单二:图论500

http://wenku.baidu.com/link?url=gETLFsWcgddEDRZ334EJOS7qCTab94qw5cor8Es0LINVaGMSgc9nIV-utRIDh--2UwRLvsvJ5tXFjbdpzbjygEdpGehim1i5BfzYgYWxJmu ==========  以下是最小生成树+并查集=========================[HDU]1213         How Many Tables        基础并查集★1272         小

图论五百题!

生死看淡不服就淦,这才是人生! =============================以下是最小生成树+并查集======================================[HDU]1213 How Many Tables 基础并查集★1272 小希的迷宫 基础并查集★1325&&poj1308 Is It A Tree? 基础并查集★1856 More is better 基础并查集★1102 Constructing Roads 基础最小生成树★1232 畅通工程 基

图论 500题——主要为hdu/poj/zoj

转自——http://blog.csdn.net/qwe20060514/article/details/8112550 =============================以下是最小生成树+并查集======================================[HDU]1213   How Many Tables   基础并查集★1272   小希的迷宫   基础并查集★1325&&poj1308  Is It A Tree?   基础并查集★1856   More i